import glob
import os
import shutil
from numpy.core.defchararray import lower
from openpyxl import load_workbook
import numpy as np
from selenium import webdriver
import warnings
import time
import csv

def start(languageString, path = None):
    print("Translation Service Started.")
    print("languageString: ", languageString)
    print("Path: ", path)
    languageDic = {}
    with open('./Assets/Language_List.csv') as csv_file:
        csv_reader = csv.reader(csv_file, delimiter=',')
        for row in csv_reader:
            languageDic[row[0]] = row[1]

    if languageString in languageDic:
        languageCode = languageDic[languageString]
    else:
        print("language does not exist, perhaps a typo?")
        return
    i = 0
    while i < 20:
        try:
            print("Interation: " + str(i))
            replace(languageCode, path)
        except:
                print("Exception occurred. Please close all files in Translate folder. Going to try again.")
        i += 1
    print("All files have been translated!")
def replace(languageCode, path=None):
    """
    Function will automatically translate all files to do this:
    1. Run get file names and copy the printed list to an .xlsx file
    2. Make sure the workbook for the excel file is named "translate"
    3.
    :param folder_path: string of the path you want to translate
    :param translationFile: string of the path to the excel translation document where:
        column 1: is the names of the files
        column 2: is the translated name of the files you want
    :param workbookName is just the string name of the workbook
    """
    if path == None:
        input_path = os.path.join(os.path.dirname(os.path.realpath(__file__)), "Translate").replace("\\", "/")
    else:
        input_path = path
    # translator = Translator()
    folder_path = input_path.replace("\\", "/")
    hashDict = {}
    translationDict = {}
    wb = load_workbook(filename="machinelearning_translation.xlsx", read_only=True)
    ws = wb['machine']  # ws is now an IterableWorksheet
    for row in ws.rows:
        translationDict[row[0].value] = row[1].value

    counter = 0
    for path, subdirs, files in os.walk(folder_path):
        for name in files + subdirs:
            # print(name)
            file_path = os.path.join(path, name)
            # new_name = translator.translate(name).text

            if not stringHasChineseChar(name):  # if not Chinese then skip it
                new_name = name
            elif name not in translationDict:  # if it's not in translationDict then get it from google
                new_name = clean(translate(name, languageCode))
            else:
                new_name = clean(translationDict[name])  # otherwise just grab it from here the files
            # new_name = getTranslation(name, translationDict)
            new_path_name = os.path.join(path, new_name)

            try:
                if name not in hashDict and name != "GoogleTranslateFiles.py":
                    if file_path != new_path_name:
                        os.rename(file_path, new_path_name)
                        print("----------------------------------------------------------------")
                        print(new_name)
                        print("Original: " + file_path)
                        print("New: " + new_path_name)
                        print("----------------------------------------------------------------")
                    hashDict[new_path_name] = True
                    # print(new_name)
            except WindowsError:  # it's a folder so we need to make a new folder, copy files over then remove old folder
                if not os.path.exists(new_path_name):
                    os.makedirs(new_path_name)
                    copyFilesInDir(new_path_name, file_path)
                    os.remove(file_path)
                    hashDict[new_path_name] = True


            counter += 1
def getHashMap(keyList, valueList):
    returnHash = {}
    if len(keyList) != valueList:
        print("getHashMap() Error, keyList and valueList does not match!")
    else:
        i = 0
        while i < len(keyList):
            returnHash[keyList[i]] = valueList[i]
        return returnHash
def getTranslation(toBeTranslated, dict):
    """
    Gets the translation if toBeTranslated is a key on the dict otherwise just returns toBeTranslated
    :param toBeTranslated: String to be translated
    :param dict: { term: translation }
    :return String
    """
    if toBeTranslated in dict:
        return dict[toBeTranslated]
    else:
        return toBeTranslated
def translate(myInput, language):
    # To ignore the warning generated by PhantomJS -- Not officially supported by Selenium
    warnings.filterwarnings("ignore")

    # List of Languages supported
    f = open('./Assets/Language_List.csv', 'r')

    # Read data from csv file
    reader = csv.reader(f)
    lang_list = np.array([])
    for data in reader:
        lang_list = np.append(lang_list, data)

    # f = open('Language_List.csv','r')
    # Take input from the user and convert the language to lower for easy detection
    # print('Please wait....')

    # Start measuring the time
    time_start = time.time()

    myLang = language.lower()

    # Find index of the desired language from the list
    # Set the url language code as per selected language
    index = np.where(lang_list == myLang)[0][0]
    if index % 2 == 0:
        to_lang = lang_list[index+1]
    else:
        to_lang = lang_list[index]

    # Construct the complete URL to search
    base_url = 'https://translate.google.com/#'
    from_lang = 'en'
    final_url = base_url + from_lang + '/' + to_lang

    # Initialize Selenium Driver
    # PhantomJS is used, Chrome is kept as backup for debugging
    driver = webdriver.PhantomJS('./Selenium Web Drivers/phantomjs.exe')
    # driver = webdriver.Chrome('./Selenium Web Drivers/chromedriver.exe')

    # Perform operation to detect the translated text
    driver.set_page_load_timeout(30)        # Incase Page doesn't load
    driver.get(final_url)                   # Search the URL
    driver.find_element_by_id('source').send_keys(myInput.lower())  # Input the Desired text to be translated
    # driver.find_element_by_id('gt-submit').click()          # Click on the translate button (not Mandatory)
    time.sleep(1)
    text_output = driver.find_element_by_xpath('//div/div[2]/div[3]/div')   # Get the output text

    time.sleep(1)   # Else it does not print the data

    # Stop Measuring the time
    time_end = time.time()
    time_taken = time_end - time_start  # Time required
    f.close()
    # print('The amount of time taken to run the script is %.3f' %time_taken)
    # driver.quit()
    return str(text_output.text)
def copyFilesInDir(dest, source):
    for file in glob.glob(os.path.join(source,"*.txt")):
        shutil.copy2(file,dest)
def clean(inputString):

    newStr = inputString\
        .replace("\n", "")\
        .replace("?", "")\
        .replace("!", "")\
        .replace(",", "")\
        .replace(":", "")
    return newStr
def stringHasChineseChar(inputString):
    for char in inputString:
        if hasChineseChar(char):
            return True
    return False
def hasChineseChar(inputString):
    cjk_ranges = [
        (0x4E00, 0x62FF),
        (0x6300, 0x77FF),
        (0x7800, 0x8CFF),
        (0x8D00, 0x9FCC),
        (0x3400, 0x4DB5),
        (0x20000, 0x215FF),
        (0x21600, 0x230FF),
        (0x23100, 0x245FF),
        (0x24600, 0x260FF),
        (0x26100, 0x275FF),
        (0x27600, 0x290FF),
        (0x29100, 0x2A6DF),
        (0x2A700, 0x2B734),
        (0x2B740, 0x2B81D),
        (0x2B820, 0x2CEAF),
        (0x2CEB0, 0x2EBEF),
        (0x2F800, 0x2FA1F)
    ]
    char = ord(inputString)
    for bottom, top in cjk_ranges:
        if char >= bottom and char <= top:
            return True
    return False

# start("chinese", "C:/Users/Frank/Desktop/赠品")




# print(stringHasChineseChar("6-有哪些人工智能的问题"))

# print(translate("获得面试", "zh-cn"))
